package ;
import haxe.Http;

/**
 * ClientData represents a connected Client.
 * 
 * It also implements the ServerApi interface, 
 * acting as a middleman between Client and NekoServer
 * 
 * @author ben
 */

class ClientProxy extends haxe.remoting.AsyncProxy< ClientApi > {}

class ClientData implements ServerApi {
	public var client : ClientProxy;
	public var id : Int;
	public function new( cnx : haxe.remoting.SocketConnection, userId : Int ) {
		client = new ClientProxy( cnx.client );
		id = userId;
		client.setId( id );
		for ( u in NekoServer.users )
			if ( u.id != id ) {
				u.client.addUser( id );
				client.addUser( u.id );
			}
	}
	
	public function removeUser( userId : Int ){
		client.removeUser( userId );
	}
	
	public function say(s: String) {
		for ( u in NekoServer.users )
			u.client.said( id , s);		
	}
}