package ;

import haxe.Timer;
import haxe.remoting.SocketProtocol;
import js.Dom;
import js.Lib;
import js.SWFObject;

class ServerProxy extends haxe.remoting.AsyncProxy< ServerApi > {}

class JSClient implements ClientApi {	
	public static var client : JSClient;
	
	public var id : Int;
	public var _socket : haxe.remoting.Socket;
	public var _server : ServerProxy;
	public var _users : List< Int >;
	
	public static function main() {
		client = new JSClient();
	}
	
	static function send() {
		var fe:Dom.FormElement = cast Lib.document.getElementById('text');
		var msg:String = cast fe.value;		
		if (msg == null || msg.length==0) return;
		fe.value = "";
		JSClient.client._server.say(msg);
	}	
	

	public function onConnect( b: Bool) {
		message("Connected");
	}

	public function onClose() {
		message("Disconnected");
	}
	
	public function new() {
		var swfo = new SWFObject("flashsocket.swf", "flashsocket", 1, 1, "9", "#ffffff"); 
		swfo.addParam("allowScriptAccess", "always"); 
		swfo.write("flashcontent");

		var me = this;
		
		// wait for the flash socket to load
		message("Loading...");
		Timer.delay(function() {
			me._socket = new haxe.remoting.Socket("flashsocket");
			me._socket.onConnect = me.onConnect;
			me._socket.onClose = me.onClose;
			me.message("Connecting...");
			me._socket.connect( "localhost", 4040 );
			var context = new haxe.remoting.Context();
			context.addObject( "client", me );
			var cnx = haxe.remoting.SocketConnection.create(me._socket,context);
			me._server = new ServerProxy( cnx.ClientData );
		},500);
	}

	public function setId( id : Int ) {
		message("Welcome client " + id);
		this.id = id;
	}
	
	public function addUser( id : Int ) {
		if ( _users == null ) 
			_users = new List();
		_users.add( id );
		
		message("Client " + id + " is online.");
	}

	public function removeUser( id : Int ) {
		for ( u in _users )
			if ( u == id ) {
			_users.remove( u );
			}
			
		message("Client " + id + " disconnected.");
	}
	
	public function said(id:Int, msg:String) {
		message("Client " + id + " said: " + StringTools.htmlEscape(msg));
	}
	
	public function message(m:String) {
		var el = Lib.document.createElement('p');		
		el.innerHTML = m;
		Lib.document.getElementById('messages').appendChild(el);
		Lib.window.scrollTo(0, 1000000000); // scroll the window down
	}
}
